% Software for the evaluation of laser-induced stripes in cell nuclei.
% Negative Stripes
% 
% The method is described here:
% Martin Mistrik, Eva Vesela, et al:
% Cells and Stripes: A novel quantitative photo-manipulation technique
% Scientific Reports, to appear.

% Main file: Segment_and_Track, see the documentation there

% If an object if lost in previous time
% this function looks into more distant past to suggest where it might be
% Searches for the last info about the object

function argout = doplnvysl_dna(argin1,argin2)

celkvysl = argin1; % list of recognized objects in the previous time
i = argin2; % current time (index of the file in the Data folder)

% argout = updated structure vysl
ladeni = true; % output to screen
    
if i==2 % file number two
    argout = celkvysl(1); % just copy info from file 1
    return
end

% file 3,4 ...
vysl = celkvysl(i-1); % info from the previous time
% search the past
pom = vysl.data;
plochy = [pom.area];
kde = find(plochy==0); % the lost ones
for k=1:1:length(kde)
    idx = kde(k); % index of object not recognized at time i
    delej = true; % go backwards in time
    pos = i-2; % start here
    while delej && pos>=1
        pom = celkvysl(pos);
        pom = pom.data;
        plo = pom(idx).area;
        delej = (plo==0); % still nothing found
        pos = pos-1;
    end % while
    if plo>0 % something found
        vysl.data(idx) = pom(idx); % use whatever is found
        if ladeni
            disp(['Using info about object no. ' num2str(idx) ' from time ' num2str(pos+1)])
        end
    end
end

argout = vysl;
